<%@taglib uri="http://java.sun.com/jsf/core" prefix="f" %>
<%@taglib uri="http://java.sun.com/jsf/html" prefix="h" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>

<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<f:view>
    <html xmlns="http://www.w3.org/1999/xhtml">
        <head>
			<link rel="stylesheet" type="text/css" href="css/dataTable.css" />
			<link rel="stylesheet" type="text/css" href="css/messages.css" />
			<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
            <title>Simple Forum</title>
        </head>
        <body>
			<h:messages infoClass="infoMessages" errorClass="errorMessages" showSummary="true" showDetail="false" layout="table" />

			<h2>Posts</h2>
			<h:outputText value="There is no posts there"  rendered="#{empty forumData.posts}" />

			<h:dataTable var="post" value="#{forumData.posts}" rendered="#{!empty forumData.posts}"
			 		styleClass="postsTable"
			 		headerClass="headerAlignment"
					columnClasses="numberColumn,userColumn,textColumn,dateColumn"
			 		rowClasses="oddRow,evenRow">
				<h:column>
					<f:facet name="header"><h:outputText value="ID"/></f:facet>
					<h:outputText value="#{post.id}"/>
				</h:column>
				<h:column>
					<f:facet name="header"><h:outputText value="User"/></f:facet>
					<h:outputText value="#{post.user.username}"/>
				</h:column>
				<h:column>
					<f:facet name="header"><h:outputText value="Text"/></f:facet>
					<h:outputText value="#{post.text}"/>
				</h:column>
				<h:column>
					<f:facet name="header"><h:outputText value="Date"/></f:facet>
					<h:outputText value="#{post.date}"/>
				</h:column>
			</h:dataTable>
			
			<h2>Add post</h2>
			<h:form id="addPost">
				<h:panelGrid border="1" columns="2">
					<h:outputLabel for="text" value="text:" />
					<h:panelGroup>
						<h:inputText id="text" value="#{addPostRequest.text}" required="true" label="#{msg.text_label}" >
							<f:validator validatorId="DuplicatePostValidator" />
						</h:inputText>
						<h:message for="text" infoClass="infoMessages" errorClass="errorMessages" />
					</h:panelGroup>
					<h:panelGroup>&nbsp;</h:panelGroup>
					<h:panelGroup>
						<h:commandButton value="Add Post from #{user.username}" action="#{addPostRequest.addPost}" />
					</h:panelGroup>
				</h:panelGrid>
			</h:form>
			<p>
			<h:form id="logout">
				<h:commandLink action="login" value="logout" />
			</h:form>
			</p>
        </body>
    </html>
</f:view>