package org.elsysbg.courses.ip.jsf.simpleForum.validator;

import java.util.List;

import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;

import org.elsysbg.courses.ip.jsf.simpleForum.model.ForumData;
import org.elsysbg.courses.ip.jsf.simpleForum.model.ForumPost;

import com.sun.faces.util.MessageFactory;

public class DuplicatePostValidator implements Validator {

	public void validate(FacesContext context, UIComponent component, Object value)
			throws ValidatorException {
		final String text = (String) value;
		if(alreadyExists(text)) {
			final FacesMessage message = MessageFactory.getMessage(context, "validator_duplicatePost", FacesMessage.SEVERITY_ERROR);
			throw new ValidatorException(message);
		}
	}

	private boolean alreadyExists(String text) {
		final List<ForumPost> posts = ForumData.getInstance().getPosts();
		for(ForumPost post:posts) {
			if (text.equalsIgnoreCase(post.getText())){
				return true;
			}
		}
		return false;
	}

}
